# bestimme abstand zwichen primzahlen

# import
import matplotlib.pyplot as plot
from math import log

# constants
N = 10**8

PRIME = [True for i in range(0, N)]

print('calculate all prime up to', N)

for i in range(2, N):
    if PRIME[i]:
        for j in range(i*i, N, i):
            PRIME[j] = False

    if i % (N / 50) == 0:
        print('.', end='')

print('')


# durchschnitt pro intervall
count = [0 for i in range(100)]
last_prime = 2

for i in range(3, N):
    if PRIME[i]:
        diff = i - last_prime
        if diff < 100:
            count[diff] += 1
        last_prime = i


# prepare visual
ax = plot.figure().add_subplot(111)
ax.set_xlim([0, 100])
ax.set_ylim([0, N / 100])

ax.set_xlabel('Abstand')
ax.set_ylabel('Anzahl')

ax.bar(range(100), count)


plot.show()
